# This file was auto-generated by Fern from our API Definition.

from ..core.pydantic_utilities import UniversalBaseModel
import pydantic
import typing_extensions
from ..core.serialization import FieldMetadata
import typing
from .business_optional import BusinessOptional
from .executed_rules_result import ExecutedRulesResult
from .hit_rules_details import HitRulesDetails
from .user_risk_score_details import UserRiskScoreDetails
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class BusinessUserEventWithRulesResult(UniversalBaseModel):
    timestamp: float = pydantic.Field()
    """
    Timestamp of the event
    """

    user_id: typing_extensions.Annotated[str, FieldMetadata(alias="userId")] = pydantic.Field()
    """
    Transaction ID the event pertains to
    """

    event_id: typing_extensions.Annotated[typing.Optional[str], FieldMetadata(alias="eventId")] = pydantic.Field(
        default=None
    )
    """
    Unique event ID
    """

    reason: typing.Optional[str] = pydantic.Field(default=None)
    """
    Reason for the event or a state change
    """

    event_description: typing_extensions.Annotated[typing.Optional[str], FieldMetadata(alias="eventDescription")] = (
        pydantic.Field(default=None)
    )
    """
    Event description
    """

    updated_business_user_attributes: typing_extensions.Annotated[
        typing.Optional[BusinessOptional], FieldMetadata(alias="updatedBusinessUserAttributes")
    ] = None
    executed_rules: typing_extensions.Annotated[
        typing.Optional[typing.List[ExecutedRulesResult]], FieldMetadata(alias="executedRules")
    ] = None
    hit_rules: typing_extensions.Annotated[
        typing.Optional[typing.List[HitRulesDetails]], FieldMetadata(alias="hitRules")
    ] = None
    risk_score_details: typing_extensions.Annotated[
        typing.Optional[UserRiskScoreDetails], FieldMetadata(alias="riskScoreDetails")
    ] = None

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
