# This file was auto-generated by Fern from our API Definition.

from ..core.pydantic_utilities import UniversalBaseModel
import typing_extensions
import typing
from ..core.serialization import FieldMetadata
import pydantic
from .address import Address
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class ContactDetails(UniversalBaseModel):
    """
    Model for business user contact information details
    """

    email_ids: typing_extensions.Annotated[typing.Optional[typing.List[str]], FieldMetadata(alias="emailIds")] = (
        pydantic.Field(default=None)
    )
    """
    Email addresses of the contacts for a given business customer
    """

    contact_numbers: typing_extensions.Annotated[
        typing.Optional[typing.List[str]], FieldMetadata(alias="contactNumbers")
    ] = pydantic.Field(default=None)
    """
    Phone numbers to contact a given business customer
    """

    fax_numbers: typing_extensions.Annotated[typing.Optional[typing.List[str]], FieldMetadata(alias="faxNumbers")] = (
        pydantic.Field(default=None)
    )
    """
    Fax numbers to contact a business customer
    """

    websites: typing.Optional[typing.List[str]] = pydantic.Field(default=None)
    """
    Website of the company
    """

    addresses: typing.Optional[typing.List[Address]] = pydantic.Field(default=None)
    """
    Address(es) of the company
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
