# This file was auto-generated by Fern from our API Definition.

from ..core.pydantic_utilities import UniversalBaseModel
import typing_extensions
import typing
from ..core.serialization import FieldMetadata
import pydantic
from .amount import Amount
from .country_code import CountryCode
from .address import Address
from .email_id import EmailId
from .tag import Tag
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class GenericBankAccountDetails(UniversalBaseModel):
    """
    Model for any generic bank account
    """

    account_number: typing_extensions.Annotated[typing.Optional[str], FieldMetadata(alias="accountNumber")] = (
        pydantic.Field(default=None)
    )
    """
    Bank account number
    """

    account_type: typing_extensions.Annotated[typing.Optional[str], FieldMetadata(alias="accountType")] = (
        pydantic.Field(default=None)
    )
    """
    Bank account type. E.g. Checking, Savings etc.
    """

    account_balance: typing_extensions.Annotated[typing.Optional[Amount], FieldMetadata(alias="accountBalance")] = None
    bank_name: typing_extensions.Annotated[typing.Optional[str], FieldMetadata(alias="bankName")] = pydantic.Field(
        default=None
    )
    """
    Name of the bank
    """

    bank_code: typing_extensions.Annotated[typing.Optional[str], FieldMetadata(alias="bankCode")] = pydantic.Field(
        default=None
    )
    """
    Unique identifier of the bank. In some countries, this can be the same as the bank's SWIFT code
    """

    country: typing.Optional[CountryCode] = None
    name: typing.Optional[str] = pydantic.Field(default=None)
    """
    Name of the account holder
    """

    bank_address: typing_extensions.Annotated[typing.Optional[Address], FieldMetadata(alias="bankAddress")] = None
    email_id: typing_extensions.Annotated[typing.Optional[EmailId], FieldMetadata(alias="emailId")] = None
    special_instructions: typing_extensions.Annotated[
        typing.Optional[str], FieldMetadata(alias="specialInstructions")
    ] = pydantic.Field(default=None)
    """
    Special instructions to be specified if any
    """

    payment_channel: typing_extensions.Annotated[typing.Optional[str], FieldMetadata(alias="paymentChannel")] = None
    tags: typing.Optional[typing.List[Tag]] = pydantic.Field(default=None)
    """
    Additional information that can be added via tags
    """

    transit_number: typing_extensions.Annotated[typing.Optional[str], FieldMetadata(alias="transitNumber")] = (
        pydantic.Field(default=None)
    )
    """
    Transit number of the bank account
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
