# This file was auto-generated by Fern from our API Definition.

from ..core.pydantic_utilities import UniversalBaseModel
import typing_extensions
from .transaction_state import TransactionState
from ..core.serialization import FieldMetadata
import pydantic
import typing
from .transaction_updatable import TransactionUpdatable
from .device_data import DeviceData
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class TransactionEvent(UniversalBaseModel):
    """
    Model for transaction-related events
    """

    transaction_state: typing_extensions.Annotated[TransactionState, FieldMetadata(alias="transactionState")]
    timestamp: float = pydantic.Field()
    """
    Timestamp of the event
    """

    transaction_id: typing_extensions.Annotated[str, FieldMetadata(alias="transactionId")] = pydantic.Field()
    """
    Transaction ID the event pertains to
    """

    event_id: typing_extensions.Annotated[typing.Optional[str], FieldMetadata(alias="eventId")] = pydantic.Field(
        default=None
    )
    """
    Unique event ID
    """

    reason: typing.Optional[str] = pydantic.Field(default=None)
    """
    Reason for the event or a state change
    """

    event_description: typing_extensions.Annotated[typing.Optional[str], FieldMetadata(alias="eventDescription")] = (
        pydantic.Field(default=None)
    )
    """
    Event description
    """

    updated_transaction_attributes: typing_extensions.Annotated[
        typing.Optional[TransactionUpdatable], FieldMetadata(alias="updatedTransactionAttributes")
    ] = None
    meta_data: typing_extensions.Annotated[typing.Optional[DeviceData], FieldMetadata(alias="metaData")] = None

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
