# This file was auto-generated by Fern from our API Definition.

from ..core.pydantic_utilities import UniversalBaseModel
import typing_extensions
from ..core.serialization import FieldMetadata
import pydantic
import typing
from .email_id import EmailId
from .tag import Tag
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class UpiDetails(UniversalBaseModel):
    """
    Model for UPI payment method
    """

    upi_id: typing_extensions.Annotated[str, FieldMetadata(alias="upiID")] = pydantic.Field()
    """
    UPI Id number
    """

    bank_provider: typing_extensions.Annotated[typing.Optional[str], FieldMetadata(alias="bankProvider")] = (
        pydantic.Field(default=None)
    )
    """
    Bank provider name
    """

    interface_provider: typing_extensions.Annotated[typing.Optional[str], FieldMetadata(alias="interfaceProvider")] = (
        pydantic.Field(default=None)
    )
    """
    Interface provider name
    """

    name: typing.Optional[str] = pydantic.Field(default=None)
    """
    Name of the account holder
    """

    email_id: typing_extensions.Annotated[typing.Optional[EmailId], FieldMetadata(alias="emailId")] = None
    tags: typing.Optional[typing.List[Tag]] = pydantic.Field(default=None)
    """
    Additional information that can be added via tags
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
